#!/usr/bin/python

import os
import re
from subprocess import check_output
from glob import glob
from collections import defaultdict


# Archive directory
ARCHIVE_DIR = '/srv/archive/packages'


def main():
    '''
    import subprocess
    proc = subprocess.Popen(['expac', '-Ss', '%n'], stdout=subprocess.PIPE)
    cache = {}
    for pkg in proc.stdout:
        pkg = pkg.rstrip()
        pkg = pkg.decode('utf-8')
        cache['{}/{}/{}'.format(ARCHIVE_DIR, pkg[0], pkg)] = True
    '''

    cache = defaultdict(dict)
    regex = r'^(.+)-(\d+)?:?([\w\d\.+]+)-([\d\.]+)-(\w+)\.pkg.+$'

    for pkgdir in glob('/srv/ftp/pool/**/*.pkg.tar.xz'):
        pkgdir = os.path.basename(pkgdir)
        matches = re.search(regex, pkgdir)
        if not matches:
            print(pkgdir)
            continue
        pkg = matches.groups()[0]
        cache['{}/{}/{}'.format(ARCHIVE_DIR, pkg[0], pkg)] = True



    for pkgdir in glob('{}/**/*'.format(ARCHIVE_DIR)):
        if cache.get(pkgdir):
            continue

        print(pkgdir)


if __name__ == "__main__":
    main()
